//
//  RBM.h
//  
//
//  Created by Roni Mittelman on 7/31/13.
//
//

#ifndef ____ssRTRBM__
#define ____ssRTRBM__

#include <iostream>
#include <valarray>
#include <vector>
#include <arrayfire.h>
#include <af/utils.h>
#include <fstream>
#include <iostream>


#endif /* defined(____ssRTRBM__) */

#ifndef ____ContrastiveDivergence__
#include "ContrastiveDivergence.h"
#endif

using namespace af;

class ssRTRBM{
private:
    array W, Wprime, W2prime, b, binit, sinit, c, pi, phi, mu;
    array Winc, Wprime_inc, W2prime_inc, binc, binit_inc, sinit_inc, cinc, ThetaMask_inc, ThetaMask2_inc, phi_inc, mu_inc;
    array WMask, WprimeMask, ThetaMask, ThetaMask2;
    float momentum;
    ContrastiveDivergence *CD;
    array alpha_parm, lambda_parm, lambda_parm_inc, gamma;
    array learning_rate;
    array l2reg;
    array NHidden_vct, NVisible_vct;
    void update_batch(array vbatch);
    float kappa;
    int NHidden, NVisible;
    int MiniBatchLen;
    array data_GPU;
    std::valarray<int> T;

    int flag_causal, flag_share_lambda_parm;
    array OnesMatV;
    array OnesMatH;
    int flag_learn_mask;
    int num_of_nodes;
    int num_of_nodesV, num_of_nodesH;
    array compute_thetaProd(array MatA, array MatB, array W0, array OnesL, array OnesR);
    array Theta2MaskMat(array theta_vct, array OnesL, array OnesR);
    array Theta2Mat(array theta_vct);

    array sigma_function(array x);
    array sigma_function0(array x);
    array createOnesMatrix(std::valarray<int> vct);
    array l1_Theta_reg;
    array upper_diag_indices;
    array lower_diag_indices;
    float step_function_factor;
    
public:
    void set_learning_rate(float alpha0);
    void set_momentum(float momentum0);
    void load_data_to_GPU(std::vector<std::valarray<float> > data, std::valarray<int> T0);
    void load_data_to_GPU_without_reshuffling(std::vector<std::valarray<float> > data, std::valarray<int> T0);
    void save_parameters(char* filename);
    void read_parameters(char* filename);
    int getNHidden();
    void updateW(array W0);
    void update_l1_Theta_reg(float l1_Theta_reg0);
    array getW();
    array getWprime();
    array getb();
    array getc();
    
    array getPI();
    void update_params();
    array getMask();
    void setMasks(array Mat);
    std::vector<std::valarray<float> > computeH(std::vector<std::valarray<float> > data, std::valarray<int> T);
    ssRTRBM(ContrastiveDivergence *CD0, int MiniBatchLen0, float learning_rate0, int NHidden0, int NVisible0, float momentum0, float alpha_parm0, float lambda_parm_init);
    ssRTRBM(ContrastiveDivergence *CD0, int MiniBatchLen0, float learning_rate0, std::valarray<int> NHidden0_vct, std::valarray<int>  NVisible0_vct, float momentum0, float l1_Theta_reg0, int flag_learn_mask0, int flag_causal0, float alpha_parm0, float lambda_parm_init, int flag_share_lambda_parm0, float delta, float kappa0);
    ssRTRBM(ContrastiveDivergence *CD0);

    float PredictionError2(std::valarray<float> Vdata, int T0);
    float PredictionError2Half(std::valarray<float> Vdata, int T0, std::valarray<int> index);

    ~ssRTRBM();
};