//
//  DBN.cpp
//  
//
//  Created by Roni Mittelman on 7/24/13.
//
//

//#include "saveCodeBooks.h"

#include <fstream>
#include <iostream>
#include <valarray>
#include <vector>
#include "util.h"
#include "RTRBMrelease.h"
#include "ssRTRBMrelease.h"
#ifndef ____ContrastiveDivergence__
#include "ContrastiveDivergence.h"
#endif

int main(int argc, char** argv){
    char filename[200];
    char parameters_filename[200];
    int type;
    int n_CD;
    int num_of_nodes;
    std::valarray<int> NVisible;
    std::valarray<int> NHidden;
    int num_of_iterations;
    float learning_rate;
    float momentum;
    float l1_Theta_reg;
    int flag_learn_mask;
    int flag_causal;
    int flag_share_lambda_parm;
    float alpha_parm;
    float lambda_parm_init;
    float delta_parm, kappa;
    util::read_parms(filename, parameters_filename, &type, &n_CD, &num_of_nodes, &NVisible, &NHidden, &num_of_iterations, &learning_rate, &momentum, &l1_Theta_reg, &flag_learn_mask, &flag_causal, &flag_share_lambda_parm, &alpha_parm, &lambda_parm_init, &delta_parm, &kappa, argv);
    int NVisible0;
    std::vector<std::valarray<float> > data;
    std::valarray<int> Tvct;
    util::read_data(filename, &data, &Tvct, &NVisible0);
    int training_batch_size=std::min(1000,(int)data.size());  // limit the number of time-series on the GPU
    
    if ((int)NVisible.sum()!=NVisible0){
        std::cout<<"Error: the number of observations in NVisible is different from the number of observations in the data file\n";
        return -1;
    }
    
    int flag_binary_real_ssRBM;
    if ((type==0) ||(type==1)){
        if (type==0){
            flag_binary_real_ssRBM=0;
        }
        else{
            flag_binary_real_ssRBM=2;
        }
        ContrastiveDivergence CD2(n_CD, (int)NHidden.sum(), flag_binary_real_ssRBM);
        RTRBM RBHMM(&CD2, 1, learning_rate, NHidden, NVisible , momentum,l1_Theta_reg, flag_learn_mask, flag_causal, delta_parm, kappa);
        for (int i=0;i<num_of_iterations;i+=(int)data.size()){
            for (int k=0;k<(int)data.size();k+=training_batch_size){
                std::vector<std::valarray<float> > tmp_data;
                if (k+training_batch_size<(int)data.size()){
                    tmp_data.assign(data.begin()+k,data.begin()+k+training_batch_size);
                    RBHMM.load_data_to_GPU(tmp_data, Tvct[std::slice(k,training_batch_size,1)]);
                }
                else{
                    tmp_data.assign(data.begin()+k,data.end());
                    RBHMM.load_data_to_GPU(tmp_data, Tvct[std::slice(k,(int)data.size()-k,1)]);
                }
                RBHMM.update_params(); // update a single sweep over all the time-series in the training set
            }
        }
        RBHMM.save_parameters(parameters_filename); // save the learned model parameters to file
    }
    else{
        if (type==2){
            flag_binary_real_ssRBM=3;
            ContrastiveDivergence CD2(n_CD, (int)NHidden.sum(), flag_binary_real_ssRBM);
            ssRTRBM RBHMM(&CD2, 1, learning_rate, NHidden, NVisible , momentum,l1_Theta_reg, flag_learn_mask, flag_causal, alpha_parm, lambda_parm_init, flag_share_lambda_parm, delta_parm, kappa);
            for (int i=0;i<num_of_iterations;i+=(int)data.size()){
                for (int k=0;k<(int)data.size();k+=training_batch_size){
                    std::vector<std::valarray<float> > tmp_data;
                    if (k+training_batch_size<(int)data.size()){
                        tmp_data.assign(data.begin()+k,data.begin()+k+training_batch_size);
                        RBHMM.load_data_to_GPU(tmp_data, Tvct[std::slice(k,training_batch_size,1)]);
                    }
                    else{
                        tmp_data.assign(data.begin()+k,data.end());
                        RBHMM.load_data_to_GPU(tmp_data, Tvct[std::slice(k,(int)data.size()-k,1)]);
                    }
                    RBHMM.update_params(); // update a single sweep over all the time-series in the training set
                }
            }
            RBHMM.save_parameters(parameters_filename); // save the learned model parameters to file
        }
    }
    return 0;
}
